# ################################################################
# UTCMS_news.sql
# Creates news table
# ################################################################
#
#                         C A U T I O N
#
#           This script WILL ERASE all existing data
#
# ################################################################
#
# ref from: 
# refers  : user(news_user), file(news_file)
#
# ################################################################

# ################################################################
# Use UTCMS database
# ################################################################
USE UTCMS;

# ################################################################
# Drop the table if it exists
# ################################################################
DROP TABLE IF EXISTS news;

# ################################################################
# Create the news table and it's indexes
# ################################################################
CREATE TABLE news (
	news_idnt	INTEGER			NOT NULL	DEFAULT 0,
	news_user	INTEGER			NOT NULL	DEFAULT 0,
	news_time	DATETIME		NOT NULL,
	news_titl	CHAR(250)		NOT NULL,
	news_file	INTEGER			NOT NULL	DEFAULT 0,

	PRIMARY KEY ( news_idnt )
);

CREATE INDEX		news_time_ix		ON news ( news_time );
CREATE INDEX		news_user_ix		ON news ( news_user );

# ################################################################
# Grants
# ################################################################
GRANT  ALL ON news TO quest@localhost;

FLUSH PRIVILEGES;

# ################################################################
# EOF: UTCMS_news.sql
# ################################################################
